% Oscilador Astable
% ver teoria de electronica en amplificadores operacionales para ms
% detalles

clear all, close all,

t=[0:0.0001:0.2];
r1=1;r2=10; ucc=5;
r=10;c=0.001;
rc=r*c;

fac=(r2/(r1+r2))*ucc;
tp=-rc*log(r1/(r1+2*r2))



for (i=1:length(t))
    if (t(i)<tp)
        u(i)=fac+(-ucc-fac)*(1-exp(-t(i)/(rc)));
        us(i)=ucc;
        uref(i)=fac;
    elseif (t(i)<2*tp)
        u(i)=-fac+(ucc+fac)*(1-exp(-(t(i)-tp)/(rc)));
        us(i)=-ucc;
        uref(i)=-fac;
    elseif(t(i)<3*tp)
        u(i)=fac+(-ucc-fac)*(1-exp(-(t(i)-2*tp)/(rc)));
        us(i)=+ucc;
        uref(i)=fac;
    elseif(t(i)<4*tp)
        u(i)=-fac+(ucc+fac)*(1-exp(-(t(i)-3*tp)/(rc)));
        us(i)=-ucc;
        uref(i)=-fac;
    else
        u(i)=fac+(-ucc-fac)*(1-exp(-(t(i)-4*tp)/(rc)));
        us(i)=+ucc;
        uref(i)=fac;
    end
end

plot(t,u); % tension en el condensador
hold on
plot(t,us,'k'); %tension de salida
plot(t,uref,'r');%tension de referencia en la pata+ de a operacional